package common.cache;

import org.infinispan.Cache;
import org.infinispan.config.Configuration;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.remoting.transport.Address;
import org.junit.Assert;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.AbstractJUnit4SpringContextTests;

import java.util.List;
import java.util.Random;
import java.util.Set;

@ContextConfiguration(locations = {"classpath:applicationContext-test.xml"})
public class InfinispanClusterTest extends AbstractJUnit4SpringContextTests {
    @Autowired
    private InfinispanCacheFactory cacheFactory;
    @Autowired
    private DefaultCacheManager cacheManager;

    private Object object = new Object();

    @Test
    public void testRehash() {
        final Configuration conf = new Configuration();
        conf.setCacheMode(Configuration.CacheMode.DIST_ASYNC);
        conf.setFetchInMemoryState(false);
        conf.setRehashEnabled(true);
        final Cache<Integer, String> cache = cacheFactory.createCache("test-cache", conf);

        synchronized (object) {
            try {
                int i = new Random().nextInt();
                while (true) {
                    cache.put(i++, "new value");
                    object.wait(250);
                }
            } catch (InterruptedException e) {

            }
        }
    }
}
